package ejb30.issue;

import java.util.*;
import javax.persistence.*;
import java.lang.reflect.*;
import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;
import java.util.concurrent.CountDownLatch;

public class TestClient {
	
    EntityManagerFactory emf = 
       Persistence.createEntityManagerFactory("pu1", new HashMap());

    public TestClient() {
    }

    // Test1: 
    public boolean test1() {
      boolean pass = false;
      Image image = new Image();
      image.setId(5001);
      SerializableNonEntity sne = new SerializableNonEntity();
      sne.setSomeValue(1l);
      image.setCustomAttribute1(sne);
      image.setImageAttribute(11l);
      EntityManager em = emf.createEntityManager();
      EntityTransaction tx = em.getTransaction();  
      try {
	tx.begin();
	em.persist(image);
	tx.commit();
      } catch(Throwable e){
	e.printStackTrace();
      }
      em.close();

      image.getCustomAttribute1().setSomeValue(2l);
      image.setImageAttribute(21l);
      em = emf.createEntityManager();
      tx = em.getTransaction();  
      try {
	tx.begin();
        em.merge(image);
	tx.commit();
      } catch(Throwable e){
	e.printStackTrace();
      }
      emf.getCache().evictAll(); 
      em.close();

      em = emf.createEntityManager();
      try {
	image = em.find(Image.class, 5001);
	long val = image.getCustomAttribute1().getSomeValue();
	System.out.println("after merge, val="+val);
	if (val == 2l) {
	  pass = true;
	}
      } catch(Throwable e){
            e.printStackTrace();
      }
      return pass;
    }
        
    public static void main(String[] args) {    

      SimpleReporterAdapter stat = new SimpleReporterAdapter("appserver-sqe");

      stat.addDescription("JPA1 Merge issue for Lob in JavaSE");	   
      String testSuiteID = args[0];

      String testlist[]={"test1"};

      if (args.length == 1) {
	testSuiteID=args[0];
      } 

      TestClient tc = new TestClient();
      boolean result = tc.test1();
      if (result == true)  {
	stat.addStatus(testSuiteID + "test1", stat.PASS);
      } else {
	stat.addStatus(testSuiteID + "test1", stat.FAIL);
      }
      stat.printSummary(); 
    }
}
