package ejb30.issue;

import javax.ejb.Stateless;
import javax.ejb.Remote;
import javax.persistence.*;
import java.util.*;


@Stateless
@Remote({ejb30.issue.TestSessionRemote.class})
public class TestSessionBean implements TestSessionRemote {
    
    @PersistenceContext EntityManager em;

    public TestSessionBean() {
    }

    public boolean test1() {
        boolean pass= false;
        Image image = new Image();
        image.setId(5001);
        SerializableNonEntity sne = new SerializableNonEntity();
        sne.setSomeValue(1l);
        image.setCustomAttribute1(sne);
        image.setImageAttribute(11l);
        try {
            em.persist(image);
            em.flush();
        } catch(Throwable e){
            e.printStackTrace();
        }

        try {
            image = em.find(Image.class, 5001);
            long val = image.getCustomAttribute1().getSomeValue();
            System.out.println("before merge, val="+val);
            image.getCustomAttribute1().setSomeValue(2l);
            image.setImageAttribute(21l);
            em.merge(image);
            em.flush();
        } catch(Throwable e){
            e.printStackTrace();
        }

        try {
            image = em.find(Image.class, 5001);
            long val = image.getCustomAttribute1().getSomeValue();
            System.out.println("after merge, val="+val);
            if (val == 2l) {
	      pass = true;
	    }
        } catch(Throwable e){
            e.printStackTrace();
        }
        return pass;
    }


}




